<?php

/**
 * Class Files.
 * @copyright 2010 CodePeople.
*/

class Files {
  function Files(){
  }
  
  function getPath($RedPath) {
    $RedPath = str_replace('\\', '/', $RedPath);
    if(substr($RedPath, 0, 1) == "/") {
      $SysPath = dirname($_SERVER['PHP_SELF']); 
      if(substr($RedPath, -1) == "/") $RedPath = substr($RedPath, 0, -1);
      if(strlen($SysPath) == 1) return ".".$RedPath;
      elseif(strcmp($SysPath,$RedPath) == 0) return "./";  
      else {
				$s_tmp = split("/", $SysPath);
				$r_tmp = split("/", $RedPath);
				while(($r_tmp[$i] == $s_tmp[$i]) && $i < 10) $i++;
				$t_RedPath = end(split("/", $RedPath, ($i+1)));  
				if($i == count($s_tmp)) return "./".$t_RedPath;
				else return str_repeat("../", count($s_tmp)-$i).$t_RedPath;
      }
    }
    else
      return $RedPath;
  }
  
  function getFile($path){
    $cont = "";
    if($this->exists($path) && !$this->isDir($path)){
      $file = fopen($path, 'r');
      while (!feof($file)){
        $cont .= fread($file, 1024);
      }
      fclose($file);
    }//if
    return $cont;
  }//function
  
  function isDir($path){
  	return is_dir($this->getPath($path));
  }//function
  
  function exists($path){
  	return file_exists($this->getPath($path));
  }//function
  
  function renameFile($old, $new){
  	return @rename($this->getPath($old), $this->getPath($new));
  }//function
  
  // $type , file = 1, folder = 2, all = 3
  function getStruct($path, $type){
    $struct = array();
    $path = $this->getPath($path);
    
    if (!is_dir($path)){
      return $struct;
    }//if
    
    $dir = opendir($path);    
    
    while($file = readdir($dir)){
      if ($file != "." && $file != "..") {
        if($type == 1 && is_file($path.'/'.$file)){
          array_push($struct, $path.'/'.$file);
        }elseif($type == 2 && is_dir($path.'/'.$file)){
          array_push($struct, $path.'/'.$file);
        }elseif($type == 3){
          array_push($struct, $path.'/'.$file);
        }
      }//if  
    }//while
    closedir($dir);
    return $struct;
  }//function
  
  function createFile($path, $content="", $mode = 0755){
    $file = @fopen($path, 'w');
    if(@fwrite($file, $content)){
      @chmod($path, $mode);
      return true;
    }
    return false;
  }//function
  
  function createDir($dir){
    return @mkdir($this->getPath($dir));
  }//function
    
  function removeFile($path){
    return @unlink($path);
  }//function
  
  function removeTree($path){
    $path = $this->getPath($path);
    if (!is_dir($path)){
      return $this->removeFile($path);
    }else{
      $dir = opendir($path);    
      
      while($file = readdir($dir)){
        if ($file != "." && $file != "..") {
          $tmp = $path.'/'.$file;
          if(is_dir($tmp)){
            if(!$this->removeTree($tmp))
            	return false;
          }else{
            if(!$this->removeFile($tmp))
            	return false;
          }//if
        }//if  
      }//while
      closedir($dir);
      return @rmdir($path);
    }//if
  }//function
  
  /* 
  	Return true if $pathB is inside $pathA
  	Return false if not
  */
  function isInside($pathA, $pathB, $strict = true){
  	$pathA = $this->getPath($pathA);
    $pathB = $this->getPath($pathB);
    if(strpos($pathB, $pathA) === 0){
    	$pathB = substr($pathB, strlen($pathA));
    	$l = strlen($pathB);
    	if($strict){
    		return $l > 0 && strpos($pathB, '../') === false && strpos($pathB, '..') !== ($l-2);
    	}
    	return strpos($pathB, '../') === false && strpos($pathB, '..') !== ($l-2);
    }
    
    return false;
  }//function
}

?>