<?php
$dir = dirname(__FILE__);
require_once $dir.'/xml.clss.php';

/**
 * Class Players.
 * @copyright 2010 CodePeople.
*/

// CONST
define('CREATE_PLAYER_ERR', 'The music player can not be created, please verify the location of the music players directory and the writing permissions in the folder.');

class Players {
  
  //ATTRIBUTES
  var $players_path;
  var $skins_path;
  var $files;
  var $db;
  var $errors = array();
  
  //CONSTRUCTOR
  function Players(){
  	$this->files = new Files();
  	$this->skins_path = $this->files->getPath(SKINS_LOCATION);
  	$this->players_path = $this->files->getPath(PLAYERS_LOCATION);
  	$c = $this->files->getFile(DB);
  	$this->db = (strlen($c) > 0) ? unserialize($c) : array();
  }//function
	
	//PRIVATE METHODS
	function setError($error){
		$this->errors[] = $error;
  }//function
  
  function parsePlData($datas, &$plItems){
    foreach($datas as $key=>$items){
      if(strtolower($key)== 'tracklist' && is_array($items)){
        $this->parsePlData($items, $plItems);
      }elseif(strtolower($key)== 'track' && is_array($items)){
        if(count($items[0])>0){$plItems = $items;} 
        else {$plItems[] = $items;}
      }  
    }
  }//function
  
  function parseConfData($datas, &$confAttrs){
    foreach($datas as $key=>$value){
      $lowKey = strtolower($key);
      if( $lowKey == 'skinoptions' || $lowKey == 'functionality'){
      	$this->parseConfData($value, $confAttrs);
      }else{	
      	$confAttrs[$key] = $value;
      }	
    }  
  }//function
  
  //PUBLIC METHODS
  function createPlayer($data, &$id){
 
    if(empty($id)){
      $counter = 1;
      while($this->existPlayer(PLAYER_BASE.$counter)){
        $counter++;
      }
      $id = PLAYER_BASE.$counter;
      if(!$this->files->createDir($this->players_path.'/'.$id)){
      	$this->setError(CREATE_PLAYER_ERR);
    		return false;
      }
    }  
    
    $path								= $this->players_path.'/'.$id;
    $path_root					= PLAYERS_LOCATION.'/'.$id;
 		$playlist_path 			= $path_root.'/'.PLAYLIST;
 		$configuration_path = $path_root.'/'.CONFIGURATION;
 		
    // Create the playlist
    $fileCont = "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\r\n<playlist version='1' xmlns='http://xspf.org/ns/0/'>\r\n<title>SECURE-TSPlayerV4.5 Generated Playlist</title>\r\n<info>http://www.tsplayer.com</info>\r\n<trackList>";
    for($i = 0; $i < count($data['playlist_items']); $i++){
      $fileCont .= "\r\n<track>";
      foreach($data['playlist_items'][$i] as $key=>$value){
        $fileCont .= "<$key>$value</$key>";
      }
      $fileCont .= "</track>";
    }
    $fileCont .= "\r\n</trackList>\r\n</playlist>";
    
    if(!$this->files->createFile($path.'/'.PLAYLIST, $fileCont)){
    	$this->setError(CREATE_PLAYER_ERR);
    	return false;
    }
  
    // Create the configuration
    $fileCont = '<?xml version="1.0" encoding="iso-8859-1"?> 
			<tsplayer> 
				<skinoptions> 
					<skin>'.SKINS_LOCATION.'/'.$data['skin'].'</skin> 
					<playlist>'.$data['playlist'].'</playlist> 
				</skinoptions> 
				<functionality> 
					<streaming>'.$data['streaming'].'</streaming> 
					<autoplay>'.$data['autoplay'].'</autoplay> 
					<volume>'.$data['volume'].'</volume> 
					<repeat>'.$data['repeat'].'</repeat> 
					<shuffling>'.$data['shuffling'].'</shuffling> 
				</functionality> 
		</tsplayer>';
    
    if(!$this->files->createFile($path.'/'.CONFIGURATION, $fileCont)){
    	$this->setError(CREATE_PLAYER_ERR);
    	return false;
    }
    
    if(!empty($data['password'])){
    	$fileCont = $this->downloadScriptContent(PLAYLIST, $data['password']);
    	if($fileCont !== false){
      	$this->files->createFile($path.'/'.SCRIPT, $fileCont);
      	$playlist_path = $path_root.'/'.SCRIPT;
      }else{
      	$this->setError(CREATE_PLAYER_ERR);
    		return false;
      }
    }	
    
    if(!empty($data['url'])){
    	$this->db[$id] = $data['url'];
    	$this->files->createFile(DB, serialize($this->db));
    }
    
    return '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" width="400" height="500"><param name="movie" value="'.PLAYERS_LOCATION.'/'.PLAYER_SWF.'" /><param name="quality" value="high" /><param name="wmode" value="transparent" /><param name="FlashVars" value="playlistfile='.$playlist_path.'&configurationfile='.$configuration_path.'" /><embed src="'.PLAYERS_LOCATION.'/'.PLAYER_SWF.'" quality="high" wmode="transparent" flashvars="playlistfile='.$playlist_path.'&configurationfile='.$configuration_path.'" pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash" type="application/x-shockwave-flash" width="400" height="500"></embed></object>';
  }//function

  function existPlayer($playerId){
    return file_exists($this->players_path.'/'.$playerId);
  }//function

  function downloadScriptContent($path, $password){
    $result = '';
    $socket_flag = false;
    $address = EXT_SOURCE.'?pass='.$password.'&path='.$path;
    if(function_exists("curl_init")){
	  $ch = curl_init();
	  curl_setopt($ch, CURLOPT_URL, $address);
	  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	  curl_setopt ($ch, CURLOPT_HEADER, 0);
	  $result = curl_exec($ch);
	  curl_close($ch);
  	}else {
  	  $url = parse_url($address);
  	  $f = @fsockopen ($url['host'], ($url['port'] > 0 ? $url['port'] : 80), $errno, $errstr, 30);
  	  if($f){
  	   	$header = "GET " . $url['path'] . "?" . $url['query'];
  	   	$header = $header . " HTTP/1.0\r\nHost: " . $url['host'] . "\r\n\r\n";
  	   	fputs($f, $header);
  	   	$socket_flag = true;
  	  }else{
	    $f = @fopen($address, 'r');
	  }
      
	  if($f != false){
	    while (!feof($f)) {
	     	$result .= fgets($f, 1024);
	    }
	    fclose($f);
	  }
	}
    if ($result != '') {
	  $pos = strpos($result, '<?php');
	  if($pos !== false){
	    $result = substr($result, $pos);
	  }
	  return $result;
    }
	return false;	
  }//function

  //Public Methods
  function getPlayers(){
  	$struct  = $this->files->getStruct($this->players_path, 2);
  	$players = array(); 
  	
  	foreach($struct as $value){
  	  if(strpos($value, $this->skins_path) === false){
        $value = str_replace($this->players_path.'/', '', $value);
        $players[$value] = (is_array($this->db) && $this->db[$value]) ? $this->db[$value] : '';
      }//if
    }//for
  	return $players;
  }//function
  
  function getSkins(){
  	$skins = $this->files->getStruct($this->skins_path, 1);
  	$list = array();
  	for($i=0; $i < count($skins); $i++)
  		if(preg_match('/\.swf$/i', $skins[$i]))
  			$list[] = str_replace($this->skins_path.'/', '', $skins[$i]);
  	return $list;	
  }//function
  
  function removePlayer($player){
  	$path = $this->players_path.'/'.$player;
  	if(file_exists($path)){
  		unset($this->db[$player]);
  		$this->files->createFile(DB, $this->db);
  		return $this->files->removeTree($path);
  	}
  	return true;
  }//function
  
  function getPlaylist($player){
  	$path = $this->players_path.'/'.$player.'/'.PLAYLIST;
  	$items = array();
  	$this->xml = new Xml;
    $xmlArr = $this->xml->parse($path);
    if(is_array($xmlArr))
      $this->parsePlData($xmlArr, $items);
    
    return $items;
  }//function
  
  function getConfiguration($player){
  	$path = $this->players_path.'/'.$player.'/'.CONFIGURATION;
  	$attrs = array();
  	$this->xml = new Xml;
    $xmlArr = $this->xml->parse($path);
    if(is_array($xmlArr)) 
    	$this->parseConfData($xmlArr, $attrs);
    return $attrs;	
  }//function
  
  function getPassword($player){
  	$path = $this->players_path.'/'.$player.'/'.SCRIPT;
  	$fileCont = $this->files->getFile($path);
  	if(preg_match("/\\\$plaintext_pass.*/i", $fileCont, $matches)){
  		eval($matches[0]);
  		return $plaintext_pass;
  	}
  	return '';
  }//function
  
  function getErrors(){
  	return $this->errors;
  }//function
}//class
?>