<?php
//validate permissions
session_start();
if(empty($_SESSION['tsplayer_admin']))
  exit;

//include section
require_once 'class/files.clss.php';
require_once 'config/configuration.ini.php';

function getLast($path){
  $path = str_replace('\\', '/', $path);
  $bits = explode('/', $path);
  return (count($bits)>0)?($bits[count($bits)-1]):$bits[0];
}

function size_readable ($size, $retstring = null) {
  $sizes = array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
  if ($retstring === null) { $retstring = '%01.2f %s'; }
  $lastsizestring = end($sizes);
  foreach ($sizes as $sizestring) {
    if ($size < 1024) { break; }
    if ($sizestring != $lastsizestring) { $size /= 1024; }
  }
  if ($sizestring == $sizes[0]) { $retstring = '%01d %s'; } // Bytes aren't normally fractional
  return sprintf($retstring, $size, $sizestring);
}

function getStructObjArray($startPoint, $type=3){
  global $files;
  $startPoint = $files->getPath($startPoint);
  $resources_root = $files->getPath(RESOURCES_LOCATION);
  
  $result = array();
  if(is_dir($startPoint)){
  	if(empty($_REQUEST['ext']))
  		$ext = array('mp3', 'jpg');
  	else{
  		$ext = array();
  		array_push($ext, strtolower($_REQUEST['ext']));
  	}		
  		
  	$struct = $files->getStruct($startPoint, $type);
  	 
  	foreach($struct as $value){
  		if(is_dir($value))
    		$result[] = '{"label":"'.getLast($value).'", "data":"'.str_replace($resources_root, RESOURCES_LOCATION, $value).'", "isLeaf":0}';
    	else{
    		$info = pathinfo($value);
	  		if(in_array(strtolower($info['extension']), $ext))
	    		$result[] = '{"label":"'.getLast($value).'", "data":"'.str_replace($resources_root, RESOURCES_LOCATION, $value).'", "isLeaf":1, "weight":"'.size_readable(filesize($value)).'", "date":"'.date('Y/m/d', filemtime($value)).'", "ext":"'.strtolower($info['extension']).'"}';
	    	}
  	}
  }
  $result = '['.implode(',', $result).']';
  return $result;
}

$files = new Files();
if($files->isInside(RESOURCES_LOCATION, $_REQUEST['query'], false) && !empty($_REQUEST['query'])){
	print(getStructObjArray($_REQUEST['query']));
}	
?>