<?php
$dir = dirname(__FILE__);
require_once $dir.'/../class/players.clss.php';
require_once $dir.'/../class/files.clss.php';

$players = new Players($db);

// Initialization variables
$player_data = array(
									'playlist_items' 	=> '[]',
									'skin' 					 	=> '',
									'streaming'				=> 1,
									'volume' 					=> 100,
									'password' 				=> '',
									'playlist' 				=> 0,
									'autoplay' 				=> 0,
									'repeat'					=> 0,
									'shuffling'				=> 0,
									'url'							=> ''
							 );

$players_list = $players->getPlayers();

if(isset($_REQUEST['action'])){
	switch($_REQUEST['action']){
		case 'remove':
			$players->removePlayer($_REQUEST['item']);
			$players_list = $players->getPlayers();
		break;
		case 'save':
			$player_data['playlist_items'] = (isset($_REQUEST['rows'])) ? $_REQUEST['rows'] : array();
			foreach($_REQUEST as $key=>$value){
				if(isset($player_data[$key])){
					$player_data[$key] = $value;
				}
			}
			if(isset($_REQUEST['item']))
				$playerId = $_REQUEST['item'];
				
			$player_code = $players->createPlayer($player_data, $playerId);
			if($player_code != false)
				print('{"playerid":"'.$playerId.'","playercode":"'.str_replace('"', '\"', $player_code).'"}');
			else
				print('{"error":"'.str_replace('"', '\"', implode('<br />',$players->getErrors())).'"}');	
			exit;
		break;
		case 'new':
		case 'edit':
			if(isset($_REQUEST['item']) && isset($players_list[$_REQUEST['item']])){
				$playlist_items = $players->getPlaylist($_REQUEST['item']);
				$tmpItems = array();
				foreach($playlist_items as $item){
					$tmpItem = array();
					foreach($item as $attr => $value){
						$tmpItem[] = $attr.':"'.$value.'"';
					}
					$tmpItems[] = '{'.implode(',', $tmpItem).'}';
				}
				
				$player_data['playlist_items'] 	= '['.implode(',', $tmpItems).']';
				$player_data['url'] 						= $players_list[$_REQUEST['item']];
				$player_data['password'] 				= $players->getPassword($_REQUEST['item']);
				$configuration_attrs 						= $players->getConfiguration($_REQUEST['item']);
				
				foreach($configuration_attrs as $key => $value)
					$player_data[$key]=$value;
			}else{
				unset($_REQUEST['item']);
			}	
		break;
		default:
			unset($_REQUEST['action']);
		break;
	}
}	

if(!empty($_REQUEST['item'])){
	$tpl->add('item', $_REQUEST['item']);
}

$scripts .= '<script>resources_path="'.RESOURCES_LOCATION.'";Data='.$player_data['playlist_items'].';</script>';
$tpl->add('list', $players_list);
$tpl->load('leftColumn', './templates/players_list.tpl');

if(!empty($_REQUEST['action']) && $_REQUEST['action'] != 'remove'){
	$tpl->add('skinList', $players->getSkins());
	$tpl->add('skin',basename($player_data['skin']));
	$tpl->add('streaming',$player_data['streaming']);
	$tpl->add('password',$player_data['password']);
	$tpl->add('volume',$player_data['volume']);
	$tpl->add('playlist',$player_data['playlist']);
	$tpl->add('autoplay',$player_data['autoplay']);
	$tpl->add('repeat',$player_data['repeat']);
	$tpl->add('shuffling',$player_data['shuffling']);
	$tpl->add('url',$player_data['url']);
	$tpl->load('rightColumn', './templates/players_edition.tpl');
}else{
	$tpl->add('rightColumn', '<h1>Select the music player that you want to edit or create new one.</h1>');
	
}
$links .= '<link href="css/players.css" rel="stylesheet" type="text/css" />';
?>