YUI({
			loadOptional: true,
			timeout: 10000
		}).use('node', 'io', 'io-form', 'json-parse', 'yui2-yahoo', 'yui2-event', 'yui2-treeview', 'yui2-container', 'yui2-datatable', 'yui2-slider',
	function(Y) {
		// PRIVATE VARIABLES INSIDE THE CLOUSURE
		var activeStep = 0,
				slider,
				YAHOO = Y.YUI2;		
		
		// PRIVATE FUNCTIONS INSIDE THE CLOUSURE
		var showHideStep = function(){ // Show wizard steps
			Y.all('.step').setStyle('display', 'none').item(activeStep).setStyle('display', 'block');
			Y.all('#breadcrumb li').removeClass('active').item(activeStep).addClass('active');
			Y.get('#previous').setStyle('display', ((activeStep == 0) ? 'none' : 'block'));
			Y.get('#next').setStyle('display', ((activeStep == 2) ? 'none' : 'block'));
			if(activeStep == 1 && !slider){
				var slider = YAHOO.widget.Slider.getHorizSlider('slider-bg', 'slider-thumb', 0, 200, 20),
						v 		 = Y.one('#volume');
			  v.setStyle('display', 'none');
			  slider.anim = true;		
			  slider.getRealValue = function() {
		      return Math.round(this.getValue() * 0.5);
		    }
				slider.subscribe("change", function(offsetFromStart) {
				  Y.one('#volume').set('value', slider.getRealValue());
				});
				
				var val = parseFloat(v.get('value'), 10);
            val = (Y.Lang.isNumber(val)) ? val : 0;

        // convert the real value into a pixel offset
        slider.setValue(Math.round(val/0.5));

			}
			
		};
		
		// EVENTS
		
		// New player event
		Y.on('click', function(){document.location = "?section=players&action=new";}, '#new');
						
		// Show/Hide the wizard sections
		
		// Breadcrumb events
		Y.on('click', 
					function(){
						var e = this.previous();
						activeStep = 0;
						while (e){
							activeStep++;
							e = e.previous();
						}
						showHideStep();
					},
					'#breadcrumb li'
				);
		
		// Next/Previous events
		Y.on('click',
					function(e){
						activeStep += (this.get('id') == 'previous') ? -1 : 1;
						showHideStep();
					},
					['#next','#previous']
				);		
		
		// Remove player events
		Y.get('.list-container').delegate('click', function(e){
						var me = this;
						e.preventDefault();
						YUI.tsplayer_admin.createDlg({txt:"Are you sure to delete the item?",
													title:"Confirmation",
													btns:[ { text:"Yes", handler:function(){YUI.tsplayer_admin.hideDlg(this);document.location = me.get('href');}, isDefault:true },
																 { text:"No", handler:function(){YUI.tsplayer_admin.hideDlg(this);} } ]
												});			 
				 },'.remove');
		
		// PLAYLIST MANAGEMENT
		
		// Create the a cell editor for items selection
		function loadNodeData(node, fnLoadComplete, ext){
			var sUrl = 'getStruct.php?ext='+ext+'&query='+ encodeURI(node.data),
     		  callback = {
         		on: {
	         		success: function(id, oResponse, args) {
	         			var results = Y.JSON.parse(oResponse.responseText);
	              for (var i=0, j=results.length; i<j; i++) {
	                var tempNode = new YAHOO.widget.TextNode(results[i], node, false);
	                if(tempNode.isLeaf) tempNode.labelStyle = 'icon-file';
				        }
	              args.fnLoadComplete();
	            },
	              
	            failure: function(id, oResponse, args) {
	              args.fnLoadComplete();
	            }
	          },
              
            arguments: {
              "node": node,
              "fnLoadComplete": fnLoadComplete
            },
              
            timeout: 7000
          };
      
      Y.io(sUrl, callback);    
    };

		function structEditor(oEditor, oSelf, ext){
			var textField = Y.get(oEditor.container).setStyle('width', Y.get(oEditor.cell).get('offsetWidth')).appendChild(Y.Node.create('<input type="text" value="'+((oEditor.record.getData(oEditor.column.key)) ? oEditor.record.getData(oEditor.column.key) : '')+'" />')),
					structDir = textField.ancestor().appendChild(Y.Node.create('<div id="structdir" style="background-color:#FFF;overflow:auto;"></div>')),
					treeView,
					root,
					tempNode;
      
      textField.setStyle('width', (structDir.get('offsetWidth')-6)+'px');
      Y.on('key', function(e){
      	oSelf.saveCellEditor();
      }, textField, 'down:13');
	
			// Structure TreeView
			treeView = new YAHOO.widget.TreeView('structdir');
			treeView.subscribe("clickEvent", function(oArgs) {
        if(oArgs.node.isLeaf){
        	textField.set('value', escape(oArgs.node.data)); 
					oSelf._oCellEditor.value = textField.get('value');
				}	
      });
		
		  treeView.setDynamicLoad(function(node, fnLoadComplete){loadNodeData(node, fnLoadComplete, ext);}, 0);
			root = treeView.getRoot();
			tempNode = new YAHOO.widget.TextNode({data:resources_path, label:resources_path}, root, false); 
		  tempNode.iconMode = 0;
			treeView.draw();
		}
		
		//Create playlist table
		//Define columns
		var pColumnDefs = [
            {key:"annotation", label:"Title", sortable:true, resizeable:true, editor:"textbox"},
            {key:"location", label:"MP3 Location (required)", resizeable:true, editor:function(oEditor, oSelf){structEditor(oEditor, oSelf, 'mp3')}},
            {key:"info", label:"Associated Information", sortable:true, resizeable:true, editor:"textbox"},
            {key:"image", label:"Associted Image", resizeable:true, editor:function(oEditor, oSelf){structEditor(oEditor, oSelf, 'jpg')}}
        ],
				pDataSource = new YAHOO.util.DataSource(Data, {	reponseType: YAHOO.util.DataSource.TYPE_JSARRAY,
																												responseSchema: {fields: ["annotation","location","info","image"]}
																											}),
				pDataTable = new YAHOO.widget.DataTable("playlist", pColumnDefs, pDataSource);
		
		// Subscribe to events for row selection
    pDataTable.subscribe("rowMouseoverEvent", pDataTable.onEventHighlightRow);
    pDataTable.subscribe("rowMouseoutEvent", pDataTable.onEventUnhighlightRow);
    pDataTable.subscribe("rowClickEvent", pDataTable.onEventSelectRow);
		pDataTable.subscribe("cellClickEvent", pDataTable.onEventShowCellEditor);
		
    // Hook into custom event to customize save-flow of editor
    pDataTable.subscribe("editorUpdateEvent", function(oArgs) {
    	if(oArgs.editor.column.key === "active") {
        this.saveCellEditor();
      }
    });
    pDataTable.subscribe("editorBlurEvent", function(oArgs) {
      this.cancelCellEditor();
    });
    
    // Plus/Minus buttons events
    Y.on('click', function(){pDataTable.addRow({})}, '#plus');
    Y.on('click', function(){
			var selRow = pDataTable.getSelectedRows(); 
			pDataTable.deleteRow((selRow.length > 0)?(selRow[0]):pDataTable.getLastTrEl());
	  }, '#minus');
	  
	  // Generator button event
	  Y.on(	'click',
	  			function(e){
	  				var recordSet = pDataTable.getRecordSet(),
	  						f         = Y.get('#main'),
	  						callback 	= {
			         		on: {
				         		start: function(id, args){
						      		args.dlg.show();
						      	},
							      
							      end: function(id, args){
							      	YUI.tsplayer_admin.hideDlg(args.dlg);
							      },
							      
				         		complete: function(id, oResponse, args) {
				         			var result = Y.JSON.parse(oResponse.responseText),
				         					item;
				         			
				              if(result.error){
				              	YUI.tsplayer_admin.createErrorDlg(result.error);
				              }else{
				              	Y.get('#code').set('text', result.playercode);
				              	Y.get('#preview div').set('innerHTML', result.playercode);
				              	item = Y.get('#item');
				              	if(result.playerid != item.get('value')){
				              		item.set('value', result.playerid);
				              		Y.get('.active').removeClass('active');
				              		Y.get('.list-container ul').append('<li class="active"><a href="?section=players&action=edit&item='+result.playerid+'"> '+result.playerid+'</a>&nbsp;&nbsp;<a href="?section=players&action=remove&item='+result.playerid+'" class="remove"><img src="images/ctrls/remove-folder.png"></a><span class="min-text">'+Y.get('#url').get('value')+'</span></li>');
				              	}
				              }
				            },
				              
				            failure: function(id, oResponse, args) {
				            	YUI.tsplayer_admin.createErrorDlg(oResponse.responseText);
				            }
				          },
			            timeout: 7000,
			            method:'POST',
			            form:{
			            	id:'main'
			            },
			            
			            arguments:{
			            	dlg: YUI.tsplayer_admin.createLoadingDlg()
			            }
			          };
	  				
	  				for(var i=0, l=recordSet.getLength(); i<l; i++){
	  					var d = recordSet.getRecord(i).getData();
	  					for(key in d)
	  						f.append('<input type="hidden" name="rows['+i+']['+key+']" value="'+d[key]+'" />');
	  				}
	  				
	  				Y.io('main.php', callback);
	  			},
	  			'#generate'
	  		);
	  		
	  // Set slider to control the volume
	  
	}
);