<form id="main" method="post">
	<input type="hidden" id="streaming" name="streaming" value="<?=$streaming;?>" />
	<input type="hidden" id="action" name="action" value="save" />
	<input type="hidden" id="item" name="item" value="<?=$item;?>" />
	<div id="breadcrumb">
		<ul>
			<li class="active">
				Playlist
			</li>
			<li>
				Setup
			</li>
			<li>
				Output
			</li>
		</ul>	
	</div>
	<div id="playlist_container" class="step container">
		<button type="button"  id="plus" name="plus" title="Add a new row to the playlist table">+</button> <button type="button"  id="minus" name="minus" title="Remove a row from the playlist table">-</button>
		<div id="playlist"></div>
	</div>
	<div id="setup_container" class="step container">
		<div>
			Configure the visual aspect and default behavior of the music player.
		</div>
		<div>
			<table>
				<tbody>
					<tr>
						<td>
							Select a skin for the music player:
						</td>
						<td>
							<select id="skin" name="skin" class="form-field">
								<?foreach($skinList as $skinItem):?>
									<option value="<?=$skinItem;?>" <?if($skin == $skinItem):?>selected<?endif;?>><?=$skinItem;?></option>
								<?endforeach;?>
							</select>
						</td>
					</tr>
					
					<tr>
						<td>
							Enter a secure password for the music player:
						</td>
						<td>
							<input type="text" id="password" name="password" class="form-field" value="<?=$password;?>"/> <a href="#" title="Enter the password to cipher the communication between the music player and the files server." class="help">[?]</a>
						</td>
					</tr>
					
					<tr>
						<td>
							Select a volume by default:
						</td>
						<td>
							<div id="slider-bg" class="yui-h-slider" tabindex="-1" title="Slider" >
			    			<div id="slider-thumb" class="yui-slider-thumb"><img src="images/slider/thumb-n.gif"></div>
							</div>
							<input type="text" id="volume" name="volume" size=4 maxsize=3 value="<?=$volume;?>" />
						</td>
					</tr>
					
					<tr>
						<td>
							Check the box to display the playlist:
						</td>
						<td>
							<input type="checkbox" id="playlist" name="playlist" value="1" <?if($playlist == 1):?>checked<?endif;?> /> <a href="#" title="The music player can display the playlist or not. If the box is checked, the playlist will be visible." class="help">[?]</a>
						</td>
					</tr>
					
					<tr>
						<td>
							Check the box to activate the autoplay in the music player:
						</td>
						<td>
							<input type="checkbox" id="autoplay" name="autoplay" value="1" <?if($autoplay == 1):?>checked<?endif;?> /> <a href="#" title="If the box is checked, the music player plays the first song in the playlist after be loaded." class="help">[?]</a>
						</td>
					</tr>
					
					<tr>
						<td>
							Check the box to active the repeat playlist button:
						</td>
						<td>
							<input type="checkbox" id="repeat" name="repeat" value="1" <?if($repeat == 1):?>checked<?endif;?> /> <a href="#" title="If the box is checked, all the sound files in the playlist will be repeated in a loop." class="help">[?]</a>
						</td>
					</tr>
					
					<tr>
						<td>
							Check the box to active the shuffling playlist button:
						</td>
						<td>
							<input type="checkbox" id="shuffling" name="shuffling" value="1" <?if($shuffling == 1):?>checked<?endif;?> /> <a href="#" title="If the box is checked, the sound files in the playlist will be selected randomly to be played." class="help">[?]</a>
						</td>
					</tr>
				</tbody>
			</table>
		</div>
	</div>
	<div id="output_container" class="step container">
		<div>
			Copy the code generated below and paste it in your web page. Enter the web page URL where the music player will be used.
		</div>
		<table>
				<tbody>
					<tr>
						<td colspan="2">
							The music player code will be generated in the field below:<br />
							<textarea id="code" name="code"></textarea> <a href="#" title="Copy the music player code from the field and paste it in the web page where the music player will be inserted. The music player code will be generated after be pressed the 'Save & Generate' button." class="help">[?]</a>
						</td>
					</tr>
					
					<tr>
						<td align="right">
							Enter the web page URL where the music player will be inserted:
						</td>
						<td>
							<input type="text" id="url" name="url" class="form-field" value="<?=$url;?>" /> <a href="#" title="Enter the URL to the web page where the music player will be inserted. The URL will be used only as a complement informational in the administration system." class="help">[?]</a> <button type="button"  id="generate" name="generate" title="Save the music player data and generate the music player code">Save & Generate</button>
						</td>
					</tr>
				</tbody>
			</table>
			<div>
				
			</div>
			<div id="preview">
				Music player preview:<br />
				<div>
				</div>
			</div>
	</div>
	
	<div id="buttons">
		<button type="button"  id="previous" title="Go back the previous wizard step">Previous step</button>
		<button type="button"  id="next" title="Go to the next wizard step">Next step</button>
	</div>
	<br class="clearfloat" />
</form>